## Define methods for print generic function
##
## Gustavo H. Esteves
## 10/05/07
##
##


## For maigesPreRaw class
print.maigesPreRaw <- function(x, ...) {

    cat(paste("\nObject of class ", class(x), " generated at ",
    x@Date, ", \n using ", x@V.info$R.version, ".\n\n", sep=""))

    cat(paste("The object has", dim(x)[1], "spot(s) and",
    dim(x)[2], "sample(s).\n"))

    cat("\n@Data: ")
    str(x@Data)

    cat("\n@GeneGrps: ")
    str(x@GeneGrps)

    cat("\n@Paths: ")
    print(x@Paths)

    cat("\n@Layout: ")
    str(x@Layout)

    cat("\nThe gene labels available are:\n")
    print(names(x@Glabels))

    cat("\nThe sample labels available are:\n")
    print(names(x@Slabels))

    cat("\n@BadSpots: ")
    str(x@BadSpots)

    cat("\n@Notes: ")
    print(x@Notes)

    cat("\n\n")

}


## For maigesRaw class
print.maigesRaw <- function(x, ...) {

    cat(paste("\nObject of class ", class(x), " generated at ",
    x@Date, ", \n using ", x@V.info$R.version, ".\n\n", sep=""))

    cat(paste("The object has", dim(x)[1], "spot(s) and",
    dim(x)[2], "sample(s).\n"))

    cat("\n@Sf: ")
    str(x@Sf)

    cat("\n@Sb: ")
    str(x@Sb)

    cat("\n@Sdye: ")
    str(x@Sdye)

    cat("\n@Rf: ")
    str(x@Rf)

    cat("\n@Rb: ")
    str(x@Rb)

    cat("\n@Rdye: ")
    str(x@Rdye)

    cat("\n@Flag: ")
    str(x@Flag)

    cat("\n@BadSpots: ")
    str(x@BadSpots)

    cat("\n@UseSpots: ")
    str(x@UseSpots)

    cat("\n@GeneGrps: ")
    str(x@GeneGrps)

    cat("\n@Paths: ")
    print(x@Paths)

    cat("\n@Layout: ")
    str(x@Layout)

    cat("\nThe gene labels available are:\n")
    print(names(x@Glabels))
    cat("\nThe sample labels available are:\n")
    print(names(x@Slabels))

    cat("\n@Notes: ")
    print(x@Notes)

    cat("\n\n")

}


## For maiges class
print.maiges <- function(x, ...) {

    cat(paste("\nObject of class ", class(x), " generated at ",
    x@Date, ", \n using ", x@V.info$R.version, ".\n\n", sep=""))

    cat(paste("The object has", dim(x)[1], "spot(s) and",
    dim(x)[2], "sample(s).\n"))

    cat("\n@W: ")
    str(x@W)

    cat("\n@A: ")
    str(x@A)

    cat("\n@SD: ")
    str(x@SD)

    cat("\n@IC1: ")
    str(x@IC1)

    cat("\n@IC2: ")
    str(x@IC2)

    cat("\n@BadSpots: ")
    str(x@BadSpots)

    cat("\n@UseSpots: ")
    str(x@UseSpots)

    cat("\n@GeneGrps: ")
    str(x@GeneGrps)

    cat("\n@Paths: ")
    print(x@Paths)

    cat("\n@Layout: ")
    str(x@Layout)

    cat("\nThe gene labels available are:\n")
    print(names(x@Glabels))

    cat("\nThe sample labels available are:\n")
    print(names(x@Slabels))

    cat("\n@Notes: ")
    print(x@Notes)

    cat("\n\n")

}


## For maigesANOVA class
print.maigesANOVA <- function(x, ...) {

    cat(paste("\nObject of class ", class(x), " generated at ",
    x@Date, ", \n using", x@V.info$R.version, ".\n\n", sep=""))

    cat(paste("The object has", dim(x)[1], "spot(s) and",
    dim(x)[2], "sample(s).\n"))

    cat("\n@W: ")
    str(x@W)

    cat("\n@A: ")
    str(x@A)

    cat("\n@SD: ")
    str(x@SD)

    cat("\n@IC1: ")
    str(x@IC1)

    cat("\n@IC2: ")
    str(x@IC2)

    cat("\n@BadSpots: ")
    str(x@BadSpots)

    cat("\n@GeneGrps: ")
    str(x@GeneGrps)

    cat("\n@Paths: ")
    print(x@Paths)

    cat("\n@Layout: ")
    str(x@Layout)

    cat("\n@Dmatrix: ")
    str(x@Dmatrix)

    cat("\n@Cmatrix: ")
    str(x@Cmatrix)

    cat("\nThe gene labels available are:\n")
    print(names(x@Glabels))

    cat("\nThe sample labels available are:\n")
    print(names(x@Slabels))

    cat("\n@Notes: ")
    print(x@Notes)

    cat("\n\n")

}


## For maigesDE class
print.maigesDE <- function(x, ...) {

    cat(paste("\nObject of class ", class(x), " generated by ", x@Date,
    ", \n using ", x@V.info$R.version, ".\n\n", sep=""))

    cat(paste("Classifying", dim(x@stat)[1],
    "genes as Differentialy Expressed (DE) \n i ",
    dim(x@stat)[2], "test(s).\n"))

    cat(paste("\nThe method used was ", x@test, ".\n\n", sep=""))

}


## For maigesDEcluster class
print.maigesDEcluster <- print.maigesDE


## For maigesClass class
print.maigesClass <- function(x, ...) {

    cat(paste("\nObject of class ", class(x), " generated by ", x@Date,
    ", \n using ", x@V.info$R.version, ".\n\n", sep=""))

    cat(paste(dim(x@cliques)[1], "classifiers of", dim(x@cliques)[2],
    "genes, ordered by CV value.\n"))

    cat(paste("\nThe method used was ", x@method, ".\n\n", sep=""))

}


## For maigesRelNetM class
print.maigesRelNetM <- function(x, ...) {

    cat(paste("\nObject of class ", class(x), " generated by ", x@Date,
    ", \n using ", x@V.info$R.version, ".\n\n", sep=""))

    cat(paste("Relevance network analysis for a group of", dim(x@Corr1)[1],
    "genes.\n"))

    cat(paste("\nThe types compared was: ", paste(x@types, collapse=" and "),
    " from sample label ", x@Slabel, ".\n\n", sep=""))

}


## For maigesRelNetB
print.maigesRelNetB <- function(x, ...) {

    cat(paste("\nObject of class ", class(x), " generated by ", x@Date,
    ", \n using ", x@V.info$R.version, ".\n\n", sep=""))

    cat(paste("Relevance network analysis for a group of", dim(x@Corr)[1],
    "genes.\n"))

    cat(paste("\nThe type compared was: ", x@type,
    " from sample label ", x@Slabel, ".\n\n", sep=""))

}


## For maigesActMod class
print.maigesActMod <- function(x, ...) {

    cat(paste("\nObject of class ", class(x), " generated by ", x@Date,
    ", \n using ", x@V.info$R.version, ".\n\n", sep=""))

    cat(paste("Active module analysis on", length(x@modByCond[1,]),
    "genes groups.\n\n"))

}


## For maigesActNet class
print.maigesActNet <- function(x, ...) {

    cat(paste("\nObject of class ", class(x), " generated by ", x@Date,
    ", \n using ", x@V.info$R.version, ".\n\n", sep=""))

    cat(paste("Functional analysis of gene regulatory networks.\n\n"))

}
